<?php
class ControllerExtensionStarrys extends Controller {

	public function receipt() {
		$data = $this->load->language('extension/starrysreceipts');

		$this->document->setTitle($this->language->get('lang_title'));
		$this->load->model('starrys/starrys');
		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}
		$data['receipts'] = array();
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'href' => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
			'text' => $this->language->get('text_home'),
			'separator' => false
		);

		$data['breadcrumbs'][] = array(
			'href' => $this->url->link('extension/starrys', 'token=' . $this->session->data['token'], 'SSL'),
			'text' => $this->language->get('lang_starrys'),
			'separator' => ' :: '
		);

		$data['breadcrumbs'][] = array(
			'href' => $this->url->link('starrys/receipts', 'token=' . $this->session->data['token'], 'SSL'),
			'text' => $this->language->get('lang_heading'),
			'separator' => ' :: '
		);

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];
			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}
		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}
		$modeldata = array(
			'start'                  => ($page - 1) * $this->config->get('config_admin_limit'),
			'limit'                  => $this->config->get('config_admin_limit')
		);
		$order_total = $this->model_starrys_starrys->getTotalReceipts($modeldata);

		$results = $this->model_starrys_starrys->getReceipts($modeldata);
		foreach ($results as $result) {

			$data['receipts'][] = array(
				'order_id'      => $result['order_id'],
				'receipt_id'      => $result['id'],
				'status'        => $result['is_print']?'Напечатан':'В процессе печати',
				'date_added'    => date($this->language->get('date_format_short'), $result['date_added']),
				'type'    => $this->language->get('lang_type_'.$result['type']),

			);
		}

		$pagination = new Pagination();
		$pagination->total = $order_total;
		$pagination->page = $page;
		$pagination->limit = $this->config->get('config_admin_limit');
		$pagination->text = $this->language->get('text_pagination');
		$pagination->url = $this->url->link('extension/starrys/receipt', 'token=' . $this->session->data['token'] .  '&page={page}', 'SSL');

		$data['pagination'] = $pagination->render();


		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/starrys_receipt.tpl', $data));
	}

	public function index() {
		$data = $this->load->language('extension/starryssettings');

		$this->load->model('setting/setting');
		//$this->load->model('extension/starrys');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$settings = array_merge($this->model_setting_setting->getSetting('starrys'), $this->request->post);
			$this->model_setting_setting->editSetting('starrys', $settings);
			$this->session->data['success'] = $this->language->get('lang_text_success');
			$this->response->redirect($this->url->link('extension/starrys&token=' . $this->session->data['token']));
		}

		$this->document->setTitle($this->language->get('lang_heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'href' => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
			'text' => $this->language->get('text_home'),
			'separator' => false
		);

		$data['breadcrumbs'][] = array(
			'href' => $this->url->link('extension/starrys', 'token=' . $this->session->data['token'], 'SSL'),
			'text' => $this->language->get('lang_starrys_settings'),
			'separator' => ' :: '
		);


		$data['action'] = $this->url->link('extension/starrys', 'token=' . $this->session->data['token'], 'SSL');
		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		$this->load->model('starrys/starrys');

		$data['payment_methods'] = $this->model_starrys_starrys->getPayments();



		$data['token'] = $this->session->data['token'];

		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=payment', true);

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->request->post['starrys_endpoint'])) {
			$data['starrys_endpoint'] = $this->request->post['starrys_endpoint'];
		} else {
			$data['starrys_endpoint'] = $this->config->get('starrys_endpoint')?$this->config->get('starrys_endpoint'):"https://kkt.chekonline.ru";
		}
		if (isset($this->request->post['starrys_group'])) {
			$data['starrys_group'] = $this->request->post['starrys_group'];
		} else {
			$data['starrys_group'] = $this->config->get('starrys_group');
		}
		if (isset($this->request->post['starrys_client_id'])) {
			$data['starrys_client_id'] = $this->request->post['starrys_client_id'];
		} else {
			$data['starrys_client_id'] = $this->config->get('starrys_client_id');
		}
		if (isset($this->request->post['starrys_cashier_password'])) {
			$data['starrys_cashier_password'] = $this->request->post['starrys_cashier_password'];
		} else {
			$data['starrys_cashier_password'] = $this->config->get('starrys_cashier_password');
		}
		if (isset($this->request->post['starrys_admin_password'])) {
			$data['starrys_admin_password'] = $this->request->post['starrys_admin_password'];
		} else {
			$data['starrys_admin_password'] = $this->config->get('starrys_admin_password');
		}
		if (isset($this->request->post['starrys_sec_since_turn_open'])) {
			$data['starrys_sec_since_turn_open'] = $this->request->post['starrys_sec_since_turn_open'];
		} else {
			$data['starrys_sec_since_turn_open'] = $this->config->get('starrys_sec_since_turn_open');
		}
		if (isset($this->request->post['starrys_docs_in_turn'])) {
			$data['starrys_docs_in_turn'] = $this->request->post['starrys_docs_in_turn'];
		} else {
			$data['starrys_docs_in_turn'] = $this->config->get('starrys_docs_in_turn');
		}

		if (isset($this->request->post['starrys_cert_path'])) {
			$data['starrys_cert_path'] = $this->request->post['starrys_cert_path'];
		} else {
			$data['starrys_cert_path'] = $this->config->get('starrys_cert_path');
		}
		if (isset($this->request->post['starrys_key_path'])) {
			$data['starrys_key_path'] = $this->request->post['starrys_key_path'];
		} else {
			$data['starrys_key_path'] = $this->config->get('starrys_key_path');
		}
		if (isset($this->request->post['starrys_cert_password'])) {
			$data['starrys_cert_password'] = $this->request->post['starrys_cert_password'];
		} else {
			$data['starrys_cert_password'] = $this->config->get('starrys_cert_password');
		}


		if (isset($this->request->post['starrys_product_nds'])) {
			$data['starrys_product_nds'] = $this->request->post['starrys_product_nds'];
		} else {
			$data['starrys_product_nds'] = $this->config->get('starrys_product_nds');
		}
		if (isset($this->request->post['starrys_delivery_nds'])) {
			$data['starrys_delivery_nds'] = $this->request->post['starrys_delivery_nds'];
		} else {
			$data['starrys_delivery_nds'] = $this->config->get('starrys_delivery_nds');
		}


		if (isset($this->request->post['starrys_payment_methods'])) {
			$data['starrys_payment_methods'] = $this->request->post['starrys_payment_methods'];
		} else {
			$data['starrys_payment_methods'] = ($this->config->get('starrys_payment_methods'))?$this->config->get('starrys_payment_methods'):array();
		}

		if (isset($this->request->post['starrys_statuses_print'])) {
			$data['starrys_statuses_print'] = $this->request->post['starrys_statuses_print'];
		} else {
			$data['starrys_statuses_print'] = ($this->config->get('starrys_statuses_print'))?$this->config->get('starrys_statuses_print'):array();
		}

		if (isset($this->request->post['starrys_statuses_return'])) {
			$data['starrys_statuses_return'] = $this->request->post['starrys_statuses_return'];
		} else {
			$data['starrys_statuses_return'] = ($this->config->get('starrys_statuses_return'))?$this->config->get('starrys_statuses_return'):array();
		}


		if (isset($this->request->post['starrys_tax_mode'])) {
			$data['starrys_tax_mode'] = $this->request->post['starrys_tax_mode'];
		} else {
			$data['starrys_tax_mode'] = $this->config->get('starrys_tax_mode');
		}

		if (isset($this->request->post['starrys_log'])) {
			$data['starrys_log'] = $this->request->post['starrys_log'];
		} else {
			$data['starrys_log'] = $this->config->get('starrys_log');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');
		$data['ajax_link'] = $this->url->link('extension/starrys/check', 'token=' . $this->session->data['token'], 'SSL');

		$this->response->setOutput($this->load->view('extension/starrys_settings.tpl', $data));
	}


	public function check() {
		$result = false;
		if (method_exists($this->load, "library")) {
            $this->load->library('starrys');
        }
        $starrys = new Starrys($this->registry);

		$api = $starrys->init_api();

		$result = $api->batchExec(array(new Starrys\Cashbox\Api\Command("NoOperation")));

		if($this->config->get('starrys_log')) {
			$starrys->writeLog('request', $api);
			$starrys->writeLog('response', $result);
		}
		if($result->code == 200 && !$result->response->Error && $result->response->Responses){
			foreach($result->response->Responses as $r) {
				if($r->Path == '/fr/api/v2/NoOperation' && !$r->Response->Error){
					$result = 'Соединение с кассой установлено';
				}
			}
		} elseif($result->code == 200 && $result->response->Error) {
			$result = implode(',', $result->response->ErrorMessages);
		} else {
			$result = "Код ответа: ".$result->code."\nОтвет: ".$result->error;
		}
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($result));
	}


	private function validate() {
		if (!$this->user->hasPermission('modify', 'extension/starrys')) {
			$this->error['warning'] = $this->language->get('invalid_permission');
		}

		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}



}