<?php
class ControllerModuleStarryscashbox extends Controller {
	private $error = array();

	public function index() {
		$this->language->load('module/starryscashbox');

		$this->document->setTitle($this->language->get('heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => false
		);

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_module'),
			'href'      => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => ' :: '
		);

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('module/starryscashbox', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => ' :: '
		);

		$data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');

		$data['heading_title'] = $this->language->get('heading_title');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['text_installed'] = $this->language->get('text_installed');

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('module/starryscashbox.tpl', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'module/starryscashbox')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}

	public function install() {
		$this->load->model('setting/setting');

		$settings = $this->model_setting_setting->getSetting('starrys');
		$settings['starrys_show_menu'] = 1;
		$this->model_setting_setting->editSetting('starrys', $settings);
		$value = array(
			'starrys_endpoint'				=> '',
			'starrys_group'					=> '',
			'starrys_client_id'				=> '',
			'starrys_cashier_password'		=> '',
			'starrys_admin_password'		=> '',
			'starrys_sec_since_turn_open'	=> '86000',
			'starrys_docs_in_turn'			=> '1000',
			'starrys_cert_path'				=> '',
			'starrys_key_path'				=> '',
			'starrys_cert_password'			=> '',
			'starrys_tax_mode'				=> '1',
			'starrys_show_menu'				=> 1,
			'starrys_product_nds'			=> 1,
			'starrys_delivery_nds'			=> 1,
			'starrys_log'					=> 0,
			'starrys_payment_methods'		=> array(),
			'starrys_statuses_print'		=> array(),
			'starrys_statuses_return'		=> array()
		);
		$this->model_setting_setting->editSetting('starrys',$value);
		$this->db->query("
					CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "starrys_receipt` (
					  `id` int(11) NOT NULL AUTO_INCREMENT,
					  `order_id` int(11) NOT NULL,
					  `type` varchar(10) NOT NULL,
					  `is_print` tinyint(1) NOT NULL DEFAULT '0',
					  `date_added` INT(11) NOT NULL,
					  `error` MEDIUMTEXT DEFAULT NULL,
					  PRIMARY KEY (`id`)
					) ENGINE=MyISAM  DEFAULT CHARSET=utf8;");
		$this->load->model('user/user_group');

        $this->model_user_user_group->addPermission($this->user->getId(), 'access', 'extension/starrys');
        $this->model_user_user_group->addPermission($this->user->getId(), 'modify', 'extension/starrys' );
	}

	public function uninstall() {
		$this->load->model('setting/setting');
		$this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "starrys_receipt`;");

		$settings = $this->model_setting_setting->getSetting('starrys');
		$settings['starrys_show_menu'] = 0;
		$this->model_setting_setting->editSetting('starrys', $settings);
	}
}
?>